/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateUserResponseCreated type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateUserResponseCreated{}

// CreateUserResponseCreated struct for CreateUserResponseCreated
type CreateUserResponseCreated struct {
	// The user name of the user
	Username *string `json:"username,omitempty"`
	// The identifier of the organization the user belongs to
	OrgUUID *string `json:"org_UUID,omitempty"`
	// The identifier of the user
	UUID *string `json:"UUID,omitempty"`
	// The user is an active user of the organization
	Active *string `json:"active,omitempty"`
	Name *ListUsersResponseUsersInnerName `json:"name,omitempty"`
	// The API key of the user
	Secret *string `json:"secret,omitempty"`
	Authority *ListUsersResponseUsersInnerAuthority `json:"authority,omitempty"`
	Time *ListUsersResponseUsersInnerTime `json:"time,omitempty"`
}

// NewCreateUserResponseCreated instantiates a new CreateUserResponseCreated object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateUserResponseCreated() *CreateUserResponseCreated {
	this := CreateUserResponseCreated{}
	return &this
}

// NewCreateUserResponseCreatedWithDefaults instantiates a new CreateUserResponseCreated object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateUserResponseCreatedWithDefaults() *CreateUserResponseCreated {
	this := CreateUserResponseCreated{}
	return &this
}

// GetUsername returns the Username field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetUsername() string {
	if o == nil || IsNil(o.Username) {
		var ret string
		return ret
	}
	return *o.Username
}

// GetUsernameOk returns a tuple with the Username field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetUsernameOk() (*string, bool) {
	if o == nil || IsNil(o.Username) {
		return nil, false
	}
	return o.Username, true
}

// HasUsername returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasUsername() bool {
	if o != nil && !IsNil(o.Username) {
		return true
	}

	return false
}

// SetUsername gets a reference to the given string and assigns it to the Username field.
func (o *CreateUserResponseCreated) SetUsername(v string) {
	o.Username = &v
}

// GetOrgUUID returns the OrgUUID field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetOrgUUID() string {
	if o == nil || IsNil(o.OrgUUID) {
		var ret string
		return ret
	}
	return *o.OrgUUID
}

// GetOrgUUIDOk returns a tuple with the OrgUUID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetOrgUUIDOk() (*string, bool) {
	if o == nil || IsNil(o.OrgUUID) {
		return nil, false
	}
	return o.OrgUUID, true
}

// HasOrgUUID returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasOrgUUID() bool {
	if o != nil && !IsNil(o.OrgUUID) {
		return true
	}

	return false
}

// SetOrgUUID gets a reference to the given string and assigns it to the OrgUUID field.
func (o *CreateUserResponseCreated) SetOrgUUID(v string) {
	o.OrgUUID = &v
}

// GetUUID returns the UUID field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetUUID() string {
	if o == nil || IsNil(o.UUID) {
		var ret string
		return ret
	}
	return *o.UUID
}

// GetUUIDOk returns a tuple with the UUID field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetUUIDOk() (*string, bool) {
	if o == nil || IsNil(o.UUID) {
		return nil, false
	}
	return o.UUID, true
}

// HasUUID returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasUUID() bool {
	if o != nil && !IsNil(o.UUID) {
		return true
	}

	return false
}

// SetUUID gets a reference to the given string and assigns it to the UUID field.
func (o *CreateUserResponseCreated) SetUUID(v string) {
	o.UUID = &v
}

// GetActive returns the Active field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetActive() string {
	if o == nil || IsNil(o.Active) {
		var ret string
		return ret
	}
	return *o.Active
}

// GetActiveOk returns a tuple with the Active field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetActiveOk() (*string, bool) {
	if o == nil || IsNil(o.Active) {
		return nil, false
	}
	return o.Active, true
}

// HasActive returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasActive() bool {
	if o != nil && !IsNil(o.Active) {
		return true
	}

	return false
}

// SetActive gets a reference to the given string and assigns it to the Active field.
func (o *CreateUserResponseCreated) SetActive(v string) {
	o.Active = &v
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetName() ListUsersResponseUsersInnerName {
	if o == nil || IsNil(o.Name) {
		var ret ListUsersResponseUsersInnerName
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetNameOk() (*ListUsersResponseUsersInnerName, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given ListUsersResponseUsersInnerName and assigns it to the Name field.
func (o *CreateUserResponseCreated) SetName(v ListUsersResponseUsersInnerName) {
	o.Name = &v
}

// GetSecret returns the Secret field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetSecret() string {
	if o == nil || IsNil(o.Secret) {
		var ret string
		return ret
	}
	return *o.Secret
}

// GetSecretOk returns a tuple with the Secret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetSecretOk() (*string, bool) {
	if o == nil || IsNil(o.Secret) {
		return nil, false
	}
	return o.Secret, true
}

// HasSecret returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasSecret() bool {
	if o != nil && !IsNil(o.Secret) {
		return true
	}

	return false
}

// SetSecret gets a reference to the given string and assigns it to the Secret field.
func (o *CreateUserResponseCreated) SetSecret(v string) {
	o.Secret = &v
}

// GetAuthority returns the Authority field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetAuthority() ListUsersResponseUsersInnerAuthority {
	if o == nil || IsNil(o.Authority) {
		var ret ListUsersResponseUsersInnerAuthority
		return ret
	}
	return *o.Authority
}

// GetAuthorityOk returns a tuple with the Authority field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetAuthorityOk() (*ListUsersResponseUsersInnerAuthority, bool) {
	if o == nil || IsNil(o.Authority) {
		return nil, false
	}
	return o.Authority, true
}

// HasAuthority returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasAuthority() bool {
	if o != nil && !IsNil(o.Authority) {
		return true
	}

	return false
}

// SetAuthority gets a reference to the given ListUsersResponseUsersInnerAuthority and assigns it to the Authority field.
func (o *CreateUserResponseCreated) SetAuthority(v ListUsersResponseUsersInnerAuthority) {
	o.Authority = &v
}

// GetTime returns the Time field value if set, zero value otherwise.
func (o *CreateUserResponseCreated) GetTime() ListUsersResponseUsersInnerTime {
	if o == nil || IsNil(o.Time) {
		var ret ListUsersResponseUsersInnerTime
		return ret
	}
	return *o.Time
}

// GetTimeOk returns a tuple with the Time field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateUserResponseCreated) GetTimeOk() (*ListUsersResponseUsersInnerTime, bool) {
	if o == nil || IsNil(o.Time) {
		return nil, false
	}
	return o.Time, true
}

// HasTime returns a boolean if a field has been set.
func (o *CreateUserResponseCreated) HasTime() bool {
	if o != nil && !IsNil(o.Time) {
		return true
	}

	return false
}

// SetTime gets a reference to the given ListUsersResponseUsersInnerTime and assigns it to the Time field.
func (o *CreateUserResponseCreated) SetTime(v ListUsersResponseUsersInnerTime) {
	o.Time = &v
}

func (o CreateUserResponseCreated) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateUserResponseCreated) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Username) {
		toSerialize["username"] = o.Username
	}
	if !IsNil(o.OrgUUID) {
		toSerialize["org_UUID"] = o.OrgUUID
	}
	if !IsNil(o.UUID) {
		toSerialize["UUID"] = o.UUID
	}
	if !IsNil(o.Active) {
		toSerialize["active"] = o.Active
	}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Secret) {
		toSerialize["secret"] = o.Secret
	}
	if !IsNil(o.Authority) {
		toSerialize["authority"] = o.Authority
	}
	if !IsNil(o.Time) {
		toSerialize["time"] = o.Time
	}
	return toSerialize, nil
}

type NullableCreateUserResponseCreated struct {
	value *CreateUserResponseCreated
	isSet bool
}

func (v NullableCreateUserResponseCreated) Get() *CreateUserResponseCreated {
	return v.value
}

func (v *NullableCreateUserResponseCreated) Set(val *CreateUserResponseCreated) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateUserResponseCreated) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateUserResponseCreated) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateUserResponseCreated(val *CreateUserResponseCreated) *NullableCreateUserResponseCreated {
	return &NullableCreateUserResponseCreated{value: val, isSet: true}
}

func (v NullableCreateUserResponseCreated) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateUserResponseCreated) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


